Vue.mixin({
  created: function () {
    this.inicializar();
  },
  methods: {
    inicializar: function () {
      unasus.pack.initialize();
      var status = unasus.pack.getStatus();
      if (status === undefined) {
        status = this.createStatusDefault();
      }
      if (status === null) {
        return false;
      }
      this.settings_videoquality();
      this.trackpage();
    },
    /* --------- STATUS -------- */
    createStatusDefault: function () {
      var status = new Object();
      status.status = "attended";
      status.percentage = 0;
      status.LTIvalue = 0;
      status['U4'] = false;
      status['U4T1'] = false;
      status['U4T2'] = false;
      status['U4T3'] = false;
      status['U4T4'] = false;
      unasus.pack.setStatus(status);
      return status;
    },
    /* ---------- NAVIGATION ----------*/
    createDefaultNavigation: function () {
      var navegacao = new Object();
      navegacao.previous = "";
      navegacao.current = "";
      return navegacao;
    },
    trackpage: function (slide, modal) {
      var navigation = new Object();
      var localizacao_atual = window.location.href.substr(window.location.href.lastIndexOf("/") + 1);
      var res_atual = localizacao_atual.replace(".html", "");
      res_atual = res_atual.replace("#", "");
      var old_navigation = unasus.pack.getPersistence('NAVIGATION');
      if (old_navigation === undefined) {
        old_navigation = this.createDefaultNavigation();
      }
      if (old_navigation === null) {
        return false;
      }
      if (res_atual.indexOf("?") > -1) {
        res_atual = res_atual.substr(0, res_atual.indexOf("?"));
      }
      if (res_atual !== old_navigation.current) {
        navigation.previous = old_navigation.current;
        navigation.current = res_atual;
        unasus.pack.setPersistence('NAVIGATION', navigation);
      }
    },
    /* ---------- ANSWER ----------*/
    caso_resposta: function (arrayQuestions, stage) {
      var answer = new Object();
      answer.stage = stage;
      answer.questions = arrayQuestions;
      unasus.pack.setPersistence('ANSWER', answer);
    },
    /* --- VIDEO --- */
    createDefaultVideo: function () {
      
      //Aqui é carregado a partir do unasus.pack quais as resoluções disponíveis, definidas no arquivo json
      var resolutions = unasus.pack.getVideoResolutions();
      //Aqui é criado e armazenado um objeto video_default, uma vez que não foi encontrado nenhum vídeo armazenado na criação do old_video
      var video_default = new Object();
      if (resolutions) {
        video_default.resolution = resolutions[0];
      } else {
        video_default.resolution = '360p';
      }
      unasus.pack.setPersistence('VIDEO', video_default);
      return video_default;
    },
    settings_videoquality: function (resolution) {
      
      //Aqui o objeto VIDEO que contém a resolução padrão para os vídeos é carregado
      var old_video = unasus.pack.getPersistence('VIDEO');
      var bool_changed = false;
      //Se old_video estiver vazio, significa que ainda não havia nenhuma resolução padrão salva ainda. Por isso é criado um video_default
      if (old_video === undefined) {
        old_video = this.createDefaultVideo();
      }
      if (old_video === null) {
        return false;
      }
      //Se essa função tiver sido chamada sem o parâmetro resolution significa que não deve ser setado nenhuma nova resolução, mas sim carregada
      if (!resolution) {
        return old_video.resolution;
      } else {
        //Caso a função tenha recebido o parâmetro resolution, significa que o usuário deseja setar uma nova resolução
        var video = new Object();
        video.resolution = resolution;
        //A nova resolução recebida na função só é armazenada caso seja diferente da resolução já configurada, para evitar conexões com o servidor desnecessárias.
        if (old_video.resolution !== video.resolution) {
          unasus.pack.setPersistence('VIDEO', video);
          bool_changed = true;
          return bool_changed;
        }
      }
    },
    /* --------------- Controle de Download --------------*/
    downloadControl: function (filetype, filename) {
      var download = new Object();
      var localizacao_atual = window.location.href.substr(window.location.href.lastIndexOf("/") + 1);
      var res_atual = localizacao_atual.replace(".html", "");
      download.current = res_atual;
      download.filetype = filetype;
      download.filename = filename;
      unasus.pack.setPersistence('DOWNLOAD', download);
    },
    /* --------------- Controle de Link Externo --------------*/
    externalLinkControl: function (url) {
      var link = new Object();
      var localizacao_atual = window.location.href.substr(window.location.href.lastIndexOf("/") + 1);
      var res_atual = localizacao_atual.replace(".html", "");
      link.current = res_atual;
      link.url = url;
      unasus.pack.setPersistence('EXTERNAL_LINK', link);
    },
    atualizarAndamento: function (unidadeaula) {
      var status_change = false;
//Aqui o objeto status recém-criado recebe os valores do getStatus()
      var status = unasus.pack.getStatus();
      //Caso status seja null, é realizado um setStatus enviando como parâmetro o objeto status_def, criado agora
      if (status === undefined) {
        status = this.createStatusDefault();
      }
      if (status === null) {
        return;
      }
      var u1 = 0;
      var u2 = 0;
      var u3 = 0;
      var u4 = 0;
      var u5 = 0;
      var u1t1 = 0;
      var u1t2 = 0;
      var u1t3 = 0;
      var u1t4 = 0;
      var u2t1 = 0;
      var u2t2 = 0;
      var u2t3 = 0;
      var u2t4 = 0;
      var u3t1 = 0;
      var u3t2 = 0;
      var u3t3 = 0;
      var u3t4 = 0;
      var u4t1 = 0;
      var u4t2 = 0;
      var u4t3 = 0;
      var u4t4 = 0;
      if (unidadeaula) {
        if (status[unidadeaula] !== true) {
          status[unidadeaula] = true;
          status_change = true;
        }
      }
      if (status["U1T1"] === true && status["U1T2"] === true && status["U1T3"] === true && status["U1T4"] === true) {
        if (status["U1"] !== true) {
          status["U1"] = true;
          status_change = true;
        }
      }
      if (status["U2T1"] === true && status["U2T2"] === true && status["U2T3"] === true && status["U2T4"] === true) {
        if (status["U2"] !== true) {
          status["U2"] = true;
          status_change = true;
        }
      }
      if (status["U3T1"] === true && status["U3T2"] === true && status["U3T3"] === true && status["U3T4"] === true) {
        if (status["U3"] !== true) {
          status["U3"] = true;
          status_change = true;
        }
      }
      if (status["U4T1"] === true && status["U4T2"] === true && status["U4T3"] === true && status["U4T4"] === true) {
        if (status["U4"] !== true) {
          status["U4"] = true;
          status_change = true;
        }
      }
      if (status["U1T1"] === true) {
        u1t1 = 25;
      }
      if (status["U1T2"] === true) {
        u1t2 = 25;
      }
      if (status["U1T3"] === true) {
        u1t3 = 25;
      }
      if (status["U1T4"] === true) {
        u1t4 = 25;
      }
      if (status["U2T1"] === true) {
        u2t1 = 25;
      }
      if (status["U2T2"] === true) {
        u2t2 = 25;
      }
      if (status["U2T3"] === true) {
        u2t3 = 25;
      }
      if (status["U2T4"] === true) {
        u2t4 = 25;
      }
      if (status["U3T1"] === true) {
        u3t1 = 25;
      }
      if (status["U3T2"] === true) {
        u3t2 = 25;
      }
      if (status["U3T3"] === true) {
        u3t3 = 25;
      }
      if (status["U3T4"] === true) {
        u3t4 = 25;
      }
      if (status["U4T1"] === true) {
        u4t1 = 25;
      }
      if (status["U4T2"] === true) {
        u4t2 = 25;
      }
      if (status["U4T3"] === true) {
        u4t3 = 25;
      }
      if (status["U4T4"] === true) {
        u4t4 = 25;
      }
      if (status["U5"] === true) {
        u5 = 20;
      }
      u1 = u1t1 + u1t2 + u1t3 + u1t4;
      u2 = u2t1 + u2t2 + u2t3 + u2t4;
      u3 = u3t1 + u3t2 + u3t3 + u3t4;
      u4 = u4t1 + u4t2 + u4t3 + u4t4;
      var totalpointssum = u1 + u2 + u3 + u4 + u5;
      var new_lti = 0;
      var new_per = 0;
      if (totalpointssum > 0) {
        new_per = totalpointssum;
        new_lti = totalpointssum / 100;
      }
      if (new_per > status.percentage) {
        status_change = true;
        status.percentage = new_per;
      }
      if (status.percentage >= 100) {
        if (status.status !== "completed") {
          status_change = true;
          status.status = "completed";
        }
      }
      if (status.percentage < 100 && status.percentage > 0) {
        if (status.status !== "attempted") {
          status_change = true;
          status.status = "attempted";
        }
      }
      if (status.percentage <= 0) {
        if (status.status !== "attended") {
          status_change = true;
          status.status = "attended";
        }
      }
      if (new_lti > status.LTIvalue) {
        status_change = true;
        status.LTIvalue = new_lti;
      }
      if (status_change) {
        unasus.pack.setStatus(status);
      }
    },
    montarAndamento: function () {
      var status = unasus.pack.getStatus();
      //Caso status seja null, é realizado um setStatus enviando como parâmetro o objeto status_def, criado agora
      if (status === undefined) {
        status = criarStatusDefault();
      }
      if (status === null) {
        return;
      }
      var array_unidade_aula = ["U1T1", "U1T2", "U1T3", "U1T4", "U2T1", "U2T2", "U2T3", "U2T4", "U3T1", "U3T2", "U3T3", "U3T4", "U4T1", "U4T2", "U4T3", "U4T4"];
      var array_unidade = ["U1", "U2", "U3", "U4", "U5"];
      for (var position = 0; position < array_unidade_aula.length; position++) {
        var unidadeTema = array_unidade_aula[position];
        var btn = "btn_" + array_unidade_aula[position];
        if (document.getElementById(btn)) {
          var elem = document.getElementById(btn);
          var status_elem = status[unidadeTema];
          if (status_elem === true) {
            elem.style.display = "block";
          } else {
            elem.style.display = "none";
          }
        }
      }
      for (var position = 0; position < array_unidade.length; position++) {
        var unidadeTema = array_unidade[position];
        var btn = "btn_" + array_unidade[position];
        if (document.getElementById(btn)) {
          var elem = document.getElementById(btn);
          var status_elem = status[unidadeTema];
          if (status_elem === true) {
            elem.style.display = "block";
          } else {
            elem.style.display = "none";
          }
        }
      }
      $('#progressobarra').html('<div class="progress"><div class="progress-bar progress-bar-success" role="progressbar" aria-valuenow="' + status.percentage + '" aria-valuemin="0" aria-valuemax="100" style="width: ' + status.percentage + '%">');
      if (document.getElementById("minhaporcentagem")) {
        var elem = document.getElementById("minhaporcentagem");
        elem.innerHTML = "Você acessou " + status.percentage + "% do conteúdo deste curso.";
      }
    }
  }
})